﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;
using System.Windows.Forms.Integration;
using System.Windows.Forms;
using System.Windows.Controls;

namespace FcTabControl
{
    /// <summary>
    /// Interaction logic for FcWPFTabControl.xaml
    /// </summary>
    public partial class FcWPFTabControl : System.Windows.Controls.UserControl
    {
        ObservableCollection<FcTabItem> tabItemsModel = new ObservableCollection<FcTabItem>();
        public ScrollViewer sv;
        //public static readonly DependencyProperty CloseButtonHighlightColorProperty = DependencyProperty.Register("CloseButtonHighlightColor", typeof(System.Windows.Media.Color),
        //                typeof(FcWPFTabControl), new PropertyMetadata(true));

        public static System.Windows.Media.Color CloseButtonHighlightColor
        {
            get;
            set;
        }

        public FcWPFTabControl()
        {
            InitializeComponent();

            SetDefaultColors();

            tabControl.DropDownDisplayMode = TabControlDropDownDisplayMode.Visible;
            
        }

        private void SetDefaultColors()
        {
            CloseButtonHighlightColor = Colors.DarkGray;
        }

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();

            //wire up the tabitems wired up directly in xaml
            if (this.tabControl.Items != null)
            {
                foreach (object currentItem in this.tabControl.Items)
                {
                    FcTabItem tabItem = currentItem as FcTabItem;
                    if (tabItem != null)
                    {
                        //tabItem.TabContainer = this;
                        tabItem.TabClosing += new RoutedEventHandler(newClosableTabItem_TabClosing);
                    }
                }
            }
        }

        void newClosableTabItem_TabClosing(object sender, RoutedEventArgs e)
        {
            //TODO: see if this check is redundant
            if (!e.Handled)
            {
                FcTabItem closingTab = e.OriginalSource as FcTabItem;

                closingTab.RemoveHandler(e.RoutedEvent, new RoutedEventHandler(newClosableTabItem_TabClosing));
                closingTab.RaiseEvent(e);
                closingTab.AddHandler(e.RoutedEvent, new RoutedEventHandler(newClosableTabItem_TabClosing));

                if (closingTab != null && !e.Handled)
                {

                    this.CloseTab(closingTab);
                }
            }
        }


        public FcTabItem CreateTabItem(string Title, System.Windows.Forms.UserControl fcUserControl, System.Drawing.Image menuImage)
        {
            // Create items:
            FcTabItem FcNewTabItem= new FcTabItem(Title, fcUserControl,menuImage);
            FcNewTabItem.TabClosing += new RoutedEventHandler(newClosableTabItem_TabClosing);
            //sv = new ScrollViewer();

            //sv.HorizontalScrollBarVisibility = ScrollBarVisibility.Visible;
            //sv.VerticalScrollBarVisibility= ScrollBarVisibility.Visible;
            //sv.Content = FcNewTabItem;
            tabControl.Items.Add(FcNewTabItem);
          
            //double width = 120.0 / tabControl.Items.Count;
            //foreach (FcTabItem tabItem in tabControl.Items)
            //{
            //    tabItem.HeaderWidth = width;
            //}

            

            return FcNewTabItem;
            
      
        }

        public void CloseTab(FcTabItem tab)
        {
            if (tab != null)
            {
                //remove the tab item if that's actually in the collection
                if (this.tabControl.Items.Contains(tab))
                {
                    this.tabControl.Items.Remove(tab);
                }
            }
        }
    }


}
